

# Actions


The following actions are supported:
+  [CancelExportTask](API_CancelExportTask.md) 
+  [CancelImportTask](API_CancelImportTask.md) 
+  [CancelQuery](API_CancelQuery.md) 
+  [CreateGraph](API_CreateGraph.md) 
+  [CreateGraphSnapshot](API_CreateGraphSnapshot.md) 
+  [CreateGraphUsingImportTask](API_CreateGraphUsingImportTask.md) 
+  [CreatePrivateGraphEndpoint](API_CreatePrivateGraphEndpoint.md) 
+  [DeleteGraph](API_DeleteGraph.md) 
+  [DeleteGraphSnapshot](API_DeleteGraphSnapshot.md) 
+  [DeletePrivateGraphEndpoint](API_DeletePrivateGraphEndpoint.md) 
+  [ExecuteQuery](API_ExecuteQuery.md) 
+  [GetExportTask](API_GetExportTask.md) 
+  [GetGraph](API_GetGraph.md) 
+  [GetGraphSnapshot](API_GetGraphSnapshot.md) 
+  [GetGraphSummary](API_GetGraphSummary.md) 
+  [GetImportTask](API_GetImportTask.md) 
+  [GetPrivateGraphEndpoint](API_GetPrivateGraphEndpoint.md) 
+  [GetQuery](API_GetQuery.md) 
+  [ListExportTasks](API_ListExportTasks.md) 
+  [ListGraphs](API_ListGraphs.md) 
+  [ListGraphSnapshots](API_ListGraphSnapshots.md) 
+  [ListImportTasks](API_ListImportTasks.md) 
+  [ListPrivateGraphEndpoints](API_ListPrivateGraphEndpoints.md) 
+  [ListQueries](API_ListQueries.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [ResetGraph](API_ResetGraph.md) 
+  [RestoreGraphFromSnapshot](API_RestoreGraphFromSnapshot.md) 
+  [StartExportTask](API_StartExportTask.md) 
+  [StartGraph](API_StartGraph.md) 
+  [StartImportTask](API_StartImportTask.md) 
+  [StopGraph](API_StopGraph.md) 
+  [TagResource](API_TagResource.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateGraph](API_UpdateGraph.md) 

# CancelExportTask


Cancel the specified export task.

## Request Syntax


```
DELETE /exporttasks/taskIdentifier HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [taskIdentifier](#API_CancelExportTask_RequestSyntax) **   <a name="neptunegraph-CancelExportTask-request-uri-taskIdentifier"></a>
The unique identifier of the export task.  
Pattern: `t-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "destination": "string",
   "format": "string",
   "graphId": "string",
   "kmsKeyIdentifier": "string",
   "parquetType": "string",
   "roleArn": "string",
   "status": "string",
   "statusReason": "string",
   "taskId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [destination](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-destination"></a>
The Amazon S3 URI of the cancelled export task where data will be exported to.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.

 ** [format](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-format"></a>
The format of the cancelled export task.  
Type: String  
Valid Values: `PARQUET | CSV` 

 ** [graphId](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-graphId"></a>
The source graph identifier of the cancelled export task.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-kmsKeyIdentifier"></a>
The KMS key identifier of the cancelled export task.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [parquetType](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-parquetType"></a>
The parquet type of the cancelled export task.  
Type: String  
Valid Values: `COLUMNAR` 

 ** [roleArn](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-roleArn"></a>
The ARN of the IAM role that will allow the exporting of data to the destination.  
Type: String  
Pattern: `arn:aws[^:]*:iam::\d{12}:(role|role/service-role)(/[\w+=,.@-]+)+` 

 ** [status](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-status"></a>
The current status of the export task. The status is `CANCELLING` when the export task is cancelled.  
Type: String  
Valid Values: `INITIALIZING | EXPORTING | SUCCEEDED | FAILED | CANCELLING | CANCELLED | DELETED` 

 ** [statusReason](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-statusReason"></a>
The reason that the export task has this status value.  
Type: String

 ** [taskId](#API_CancelExportTask_ResponseSyntax) **   <a name="neptunegraph-CancelExportTask-response-taskId"></a>
The unique identifier of the export task.  
Type: String  
Pattern: `t-[a-z0-9]{10}` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/CancelExportTask) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/CancelExportTask) 

# CancelImportTask


Deletes the specified import task.

## Request Syntax


```
DELETE /importtasks/taskIdentifier HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [taskIdentifier](#API_CancelImportTask_RequestSyntax) **   <a name="neptunegraph-CancelImportTask-request-uri-taskIdentifier"></a>
The unique identifier of the import task.  
Pattern: `t-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "format": "string",
   "graphId": "string",
   "parquetType": "string",
   "roleArn": "string",
   "source": "string",
   "status": "string",
   "taskId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [format](#API_CancelImportTask_ResponseSyntax) **   <a name="neptunegraph-CancelImportTask-response-format"></a>
Specifies the format of S3 data to be imported. Valid values are `CSV`, which identifies the [Gremlin CSV format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-gremlin.html) or `OPENCYPHER`, which identies the [openCypher load format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-opencypher.html).  
Type: String  
Valid Values: `CSV | OPEN_CYPHER | PARQUET | NTRIPLES` 

 ** [graphId](#API_CancelImportTask_ResponseSyntax) **   <a name="neptunegraph-CancelImportTask-response-graphId"></a>
The unique identifier of the Neptune Analytics graph.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [parquetType](#API_CancelImportTask_ResponseSyntax) **   <a name="neptunegraph-CancelImportTask-response-parquetType"></a>
The parquet type of the cancelled import task.  
Type: String  
Valid Values: `COLUMNAR` 

 ** [roleArn](#API_CancelImportTask_ResponseSyntax) **   <a name="neptunegraph-CancelImportTask-response-roleArn"></a>
The ARN of the IAM role that will allow access to the data that is to be imported.  
Type: String  
Pattern: `arn:aws[^:]*:iam::\d{12}:(role|role/service-role)(/[\w+=,.@-]+)+` 

 ** [source](#API_CancelImportTask_ResponseSyntax) **   <a name="neptunegraph-CancelImportTask-response-source"></a>
A URL identifying to the location of the data to be imported. This can be an Amazon S3 path, or can point to a Neptune database endpoint or snapshot.  
Type: String

 ** [status](#API_CancelImportTask_ResponseSyntax) **   <a name="neptunegraph-CancelImportTask-response-status"></a>
Current status of the task. Status is CANCELLING when the import task is cancelled.  
Type: String  
Valid Values: `INITIALIZING | EXPORTING | ANALYZING_DATA | IMPORTING | REPROVISIONING | ROLLING_BACK | SUCCEEDED | FAILED | CANCELLING | CANCELLED | DELETED` 

 ** [taskId](#API_CancelImportTask_ResponseSyntax) **   <a name="neptunegraph-CancelImportTask-response-taskId"></a>
The unique identifier of the import task.  
Type: String  
Pattern: `t-[a-z0-9]{10}` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/CancelImportTask) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/CancelImportTask) 

# CancelQuery


Cancels a specified query.

## Request Syntax


```
DELETE /queries/queryId HTTP/1.1
graphIdentifier: graphIdentifier
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [graphIdentifier](#API_CancelQuery_RequestSyntax) **   <a name="neptunegraph-CancelQuery-request-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

 ** [queryId](#API_CancelQuery_RequestSyntax) **   <a name="neptunegraph-CancelQuery-request-uri-queryId"></a>
The unique identifier of the query to cancel.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Raised in case of an authentication or authorization failure.    
 ** message **   
A message describing the problem.
HTTP Status Code: 403

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/CancelQuery) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/CancelQuery) 

# CreateGraph


Creates a new Neptune Analytics graph.

## Request Syntax


```
POST /graphs HTTP/1.1
Content-type: application/json

{
   "deletionProtection": boolean,
   "graphName": "string",
   "kmsKeyIdentifier": "string",
   "provisionedMemory": number,
   "publicConnectivity": boolean,
   "replicaCount": number,
   "tags": { 
      "string" : "string" 
   },
   "vectorSearchConfiguration": { 
      "dimension": number
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [deletionProtection](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-deletionProtection"></a>
Indicates whether or not to enable deletion protection on the graph. The graph can’t be deleted when deletion protection is enabled. (`true` or `false`).  
Type: Boolean  
Required: No

 ** [graphName](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-graphName"></a>
A name for the new Neptune Analytics graph to be created.  
The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!g-)[a-z][a-z0-9]*(-[a-z0-9]+)*`   
Required: Yes

 ** [kmsKeyIdentifier](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-kmsKeyIdentifier"></a>
Specifies a KMS key to use to encrypt data in the new graph.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}`   
Required: No

 ** [provisionedMemory](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-provisionedMemory"></a>
The provisioned memory-optimized Neptune Capacity Units (m-NCUs) to use for the graph. Min = 16  
Type: Integer  
Valid Range: Minimum value of 16. Maximum value of 24576.  
Required: Yes

 ** [publicConnectivity](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-publicConnectivity"></a>
Specifies whether or not the graph can be reachable over the internet. All access to graphs is IAM authenticated. (`true` to enable, or `false` to disable.  
Type: Boolean  
Required: No

 ** [replicaCount](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-replicaCount"></a>
The number of replicas in other AZs. Min =0, Max = 2, Default = 1.  
 Additional charges equivalent to the m-NCUs selected for the graph apply for each replica. 
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2.  
Required: No

 ** [tags](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-tags"></a>
Adds metadata tags to the new graph. These tags can also be used with cost allocation reporting, or used in a Condition statement in an IAM policy.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `(?!aws:)[a-zA-Z+-=._:/]+`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Required: No

 ** [vectorSearchConfiguration](#API_CreateGraph_RequestSyntax) **   <a name="neptunegraph-CreateGraph-request-vectorSearchConfiguration"></a>
Specifies the number of dimensions for vector embeddings that will be loaded into the graph. The value is specified as `dimension=`value. Max = 65,535  
Type: [VectorSearchConfiguration](API_VectorSearchConfiguration.md) object  
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "arn": "string",
   "buildNumber": "string",
   "createTime": number,
   "deletionProtection": boolean,
   "endpoint": "string",
   "id": "string",
   "kmsKeyIdentifier": "string",
   "name": "string",
   "provisionedMemory": number,
   "publicConnectivity": boolean,
   "replicaCount": number,
   "sourceSnapshotId": "string",
   "status": "string",
   "statusReason": "string",
   "vectorSearchConfiguration": { 
      "dimension": number
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-arn"></a>
The ARN of the graph.  
Type: String

 ** [buildNumber](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-buildNumber"></a>
The build number of the graph software.  
Type: String

 ** [createTime](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-createTime"></a>
The time when the graph was created.  
Type: Timestamp

 ** [deletionProtection](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-deletionProtection"></a>
A value that indicates whether the graph has deletion protection enabled. The graph can't be deleted when deletion protection is enabled.  
Type: Boolean

 ** [endpoint](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-endpoint"></a>
The graph endpoint.  
Type: String

 ** [id](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-id"></a>
The ID of the graph.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-kmsKeyIdentifier"></a>
Specifies the KMS key used to encrypt data in the new graph.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [name](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-name"></a>
The graph name. For example: `my-graph-1`.  
The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!g-)[a-z][a-z0-9]*(-[a-z0-9]+)*` 

 ** [provisionedMemory](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-provisionedMemory"></a>
The provisioned memory-optimized Neptune Capacity Units (m-NCUs) to use for the graph.  
Min = 16  
Type: Integer  
Valid Range: Minimum value of 16. Maximum value of 24576.

 ** [publicConnectivity](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-publicConnectivity"></a>
Specifies whether or not the graph can be reachable over the internet. All access to graphs is IAM authenticated.  
If enabling public connectivity for the first time, there will be a delay while it is enabled.
Type: Boolean

 ** [replicaCount](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-replicaCount"></a>
The number of replicas in other AZs.  
Default: If not specified, the default value is 1.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2.

 ** [sourceSnapshotId](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-sourceSnapshotId"></a>
The ID of the source graph.  
Type: String  
Pattern: `gs-[a-z0-9]{10}` 

 ** [status](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-status"></a>
The current status of the graph.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | RESETTING | UPDATING | SNAPSHOTTING | FAILED | IMPORTING | STARTING | STOPPING | STOPPED` 

 ** [statusReason](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-statusReason"></a>
The reason the status was given.  
Type: String

 ** [vectorSearchConfiguration](#API_CreateGraph_ResponseSyntax) **   <a name="neptunegraph-CreateGraph-response-vectorSearchConfiguration"></a>
The vector-search configuration for the graph, which specifies the vector dimension to use in the vector index, if any.  
Type: [VectorSearchConfiguration](API_VectorSearchConfiguration.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
A service quota was exceeded.    
 ** quotaCode **   
Service quota code of the resource for which quota was exceeded.  
 ** resourceId **   
The identifier of the resource that exceeded quota.  
 ** resourceType **   
The type of the resource that exceeded quota. Ex: Graph, Snapshot  
 ** serviceCode **   
The service code that exceeded quota.
HTTP Status Code: 402

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/CreateGraph) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/CreateGraph) 

# CreateGraphSnapshot


Creates a snapshot of the specific graph.

## Request Syntax


```
POST /snapshots HTTP/1.1
Content-type: application/json

{
   "graphIdentifier": "string",
   "snapshotName": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [graphIdentifier](#API_CreateGraphSnapshot_RequestSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-request-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Type: String  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

 ** [snapshotName](#API_CreateGraphSnapshot_RequestSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-request-snapshotName"></a>
The snapshot name. For example: `my-snapshot-1`.  
The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!gs-)[a-z][a-z0-9]*(-[a-z0-9]+)*`   
Required: Yes

 ** [tags](#API_CreateGraphSnapshot_RequestSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-request-tags"></a>
Adds metadata tags to the new graph. These tags can also be used with cost allocation reporting, or used in a Condition statement in an IAM policy.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `(?!aws:)[a-zA-Z+-=._:/]+`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "arn": "string",
   "id": "string",
   "kmsKeyIdentifier": "string",
   "name": "string",
   "snapshotCreateTime": number,
   "sourceGraphId": "string",
   "status": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_CreateGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-response-arn"></a>
The ARN of the snapshot created.  
Type: String

 ** [id](#API_CreateGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-response-id"></a>
The ID of the snapshot created.  
Type: String  
Pattern: `gs-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_CreateGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-response-kmsKeyIdentifier"></a>
The ID of the KMS key used to encrypt and decrypt graph data.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [name](#API_CreateGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-response-name"></a>
The name of the snapshot created.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!gs-)[a-z][a-z0-9]*(-[a-z0-9]+)*` 

 ** [snapshotCreateTime](#API_CreateGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-response-snapshotCreateTime"></a>
The snapshot creation time  
Type: Timestamp

 ** [sourceGraphId](#API_CreateGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-response-sourceGraphId"></a>
The Id of the Neptune Analytics graph from which the snapshot is created.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [status](#API_CreateGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-CreateGraphSnapshot-response-status"></a>
The current state of the snapshot.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | FAILED` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
A service quota was exceeded.    
 ** quotaCode **   
Service quota code of the resource for which quota was exceeded.  
 ** resourceId **   
The identifier of the resource that exceeded quota.  
 ** resourceType **   
The type of the resource that exceeded quota. Ex: Graph, Snapshot  
 ** serviceCode **   
The service code that exceeded quota.
HTTP Status Code: 402

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/CreateGraphSnapshot) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/CreateGraphSnapshot) 

# CreateGraphUsingImportTask


Creates a new Neptune Analytics graph and imports data into it, either from Amazon Simple Storage Service (S3) or from a Neptune database or a Neptune database snapshot.

The data can be loaded from files in S3 that in either the [Gremlin CSV format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-gremlin.html) or the [openCypher load format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-opencypher.html).

## Request Syntax


```
POST /importtasks HTTP/1.1
Content-type: application/json

{
   "blankNodeHandling": "string",
   "deletionProtection": boolean,
   "failOnError": boolean,
   "format": "string",
   "graphName": "string",
   "importOptions": { ... },
   "kmsKeyIdentifier": "string",
   "maxProvisionedMemory": number,
   "minProvisionedMemory": number,
   "parquetType": "string",
   "publicConnectivity": boolean,
   "replicaCount": number,
   "roleArn": "string",
   "source": "string",
   "tags": { 
      "string" : "string" 
   },
   "vectorSearchConfiguration": { 
      "dimension": number
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [blankNodeHandling](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-blankNodeHandling"></a>
The method to handle blank nodes in the dataset. Currently, only `convertToIri` is supported, meaning blank nodes are converted to unique IRIs at load time. Must be provided when format is `ntriples`. For more information, see [Handling RDF values](https://docs.aws.amazon.com/neptune-analytics/latest/userguide/using-rdf-data.html#rdf-handling).  
Type: String  
Valid Values: `convertToIri`   
Required: No

 ** [deletionProtection](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-deletionProtection"></a>
Indicates whether or not to enable deletion protection on the graph. The graph can’t be deleted when deletion protection is enabled. (`true` or `false`).  
Type: Boolean  
Required: No

 ** [failOnError](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-failOnError"></a>
If set to `true`, the task halts when an import error is encountered. If set to `false`, the task skips the data that caused the error and continues if possible.  
Type: Boolean  
Required: No

 ** [format](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-format"></a>
Specifies the format of S3 data to be imported. Valid values are `CSV`, which identifies the [Gremlin CSV format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-gremlin.html), `OPEN_CYPHER`, which identifies the [openCypher load format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-opencypher.html), or `ntriples`, which identifies the [RDF n-triples](https://docs.aws.amazon.com/neptune-analytics/latest/userguide/using-rdf-data.html) format.  
Type: String  
Valid Values: `CSV | OPEN_CYPHER | PARQUET | NTRIPLES`   
Required: No

 ** [graphName](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-graphName"></a>
A name for the new Neptune Analytics graph to be created.  
The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!g-)[a-z][a-z0-9]*(-[a-z0-9]+)*`   
Required: Yes

 ** [importOptions](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-importOptions"></a>
Contains options for controlling the import process. For example, if the `failOnError` key is set to `false`, the import skips problem data and attempts to continue (whereas if set to `true`, the default, or if omitted, the import operation halts immediately when an error is encountered.  
Type: [ImportOptions](API_ImportOptions.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.  
Required: No

 ** [kmsKeyIdentifier](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-kmsKeyIdentifier"></a>
Specifies a KMS key to use to encrypt data imported into the new graph.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}`   
Required: No

 ** [maxProvisionedMemory](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-maxProvisionedMemory"></a>
The maximum provisioned memory-optimized Neptune Capacity Units (m-NCUs) to use for the graph. Default: 1024, or the approved upper limit for your account.  
 If both the minimum and maximum values are specified, the final `provisioned-memory` will be chosen per the actual size of your imported data. If neither value is specified, 128 m-NCUs are used.  
Type: Integer  
Valid Range: Minimum value of 16. Maximum value of 24576.  
Required: No

 ** [minProvisionedMemory](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-minProvisionedMemory"></a>
The minimum provisioned memory-optimized Neptune Capacity Units (m-NCUs) to use for the graph. Default: 16  
Type: Integer  
Valid Range: Minimum value of 16. Maximum value of 24576.  
Required: No

 ** [parquetType](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-parquetType"></a>
The parquet type of the import task.  
Type: String  
Valid Values: `COLUMNAR`   
Required: No

 ** [publicConnectivity](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-publicConnectivity"></a>
Specifies whether or not the graph can be reachable over the internet. All access to graphs is IAM authenticated. (`true` to enable, or `false` to disable).  
Type: Boolean  
Required: No

 ** [replicaCount](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-replicaCount"></a>
The number of replicas in other AZs to provision on the new graph after import. Default = 0, Min = 0, Max = 2.  
 Additional charges equivalent to the m-NCUs selected for the graph apply for each replica. 
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2.  
Required: No

 ** [roleArn](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-roleArn"></a>
The ARN of the IAM role that will allow access to the data that is to be imported.  
Type: String  
Pattern: `arn:aws[^:]*:iam::\d{12}:(role|role/service-role)(/[\w+=,.@-]+)+`   
Required: Yes

 ** [source](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-source"></a>
A URL identifying to the location of the data to be imported. This can be an Amazon S3 path, or can point to a Neptune database endpoint or snapshot.  
Type: String  
Required: Yes

 ** [tags](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-tags"></a>
Adds metadata tags to the new graph. These tags can also be used with cost allocation reporting, or used in a Condition statement in an IAM policy.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `(?!aws:)[a-zA-Z+-=._:/]+`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Required: No

 ** [vectorSearchConfiguration](#API_CreateGraphUsingImportTask_RequestSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-request-vectorSearchConfiguration"></a>
Specifies the number of dimensions for vector embeddings that will be loaded into the graph. The value is specified as `dimension=`value. Max = 65,535   
Type: [VectorSearchConfiguration](API_VectorSearchConfiguration.md) object  
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "format": "string",
   "graphId": "string",
   "importOptions": { ... },
   "parquetType": "string",
   "roleArn": "string",
   "source": "string",
   "status": "string",
   "taskId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [format](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-format"></a>
Specifies the format of S3 data to be imported. Valid values are `CSV`, which identifies the [Gremlin CSV format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-gremlin.html), `OPENCYPHER`, which identifies the [openCypher load format](https://docs.aws.amazon.com/neptune/latest/userguide/bulk-load-tutorial-format-opencypher.html), or `ntriples`, which identifies the [RDF n-triples](https://docs.aws.amazon.com/neptune-analytics/latest/userguide/using-rdf-data.html) format.  
Type: String  
Valid Values: `CSV | OPEN_CYPHER | PARQUET | NTRIPLES` 

 ** [graphId](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-graphId"></a>
The unique identifier of the Neptune Analytics graph.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [importOptions](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-importOptions"></a>
Contains options for controlling the import process. For example, if the `failOnError` key is set to `false`, the import skips problem data and attempts to continue (whereas if set to `true`, the default, or if omitted, the import operation halts immediately when an error is encountered.  
Type: [ImportOptions](API_ImportOptions.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.

 ** [parquetType](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-parquetType"></a>
The parquet type of the import task.  
Type: String  
Valid Values: `COLUMNAR` 

 ** [roleArn](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-roleArn"></a>
The ARN of the IAM role that will allow access to the data that is to be imported.  
Type: String  
Pattern: `arn:aws[^:]*:iam::\d{12}:(role|role/service-role)(/[\w+=,.@-]+)+` 

 ** [source](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-source"></a>
A URL identifying to the location of the data to be imported. This can be an Amazon S3 path, or can point to a Neptune database endpoint or snapshot.  
Type: String

 ** [status](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-status"></a>
The status of the import task.  
Type: String  
Valid Values: `INITIALIZING | EXPORTING | ANALYZING_DATA | IMPORTING | REPROVISIONING | ROLLING_BACK | SUCCEEDED | FAILED | CANCELLING | CANCELLED | DELETED` 

 ** [taskId](#API_CreateGraphUsingImportTask_ResponseSyntax) **   <a name="neptunegraph-CreateGraphUsingImportTask-response-taskId"></a>
The unique identifier of the import task.  
Type: String  
Pattern: `t-[a-z0-9]{10}` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
A service quota was exceeded.    
 ** quotaCode **   
Service quota code of the resource for which quota was exceeded.  
 ** resourceId **   
The identifier of the resource that exceeded quota.  
 ** resourceType **   
The type of the resource that exceeded quota. Ex: Graph, Snapshot  
 ** serviceCode **   
The service code that exceeded quota.
HTTP Status Code: 402

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/CreateGraphUsingImportTask) 

# CreatePrivateGraphEndpoint


Create a private graph endpoint to allow private access from to the graph from within a VPC. You can attach security groups to the private graph endpoint.

**Note**  
VPC endpoint charges apply.

## Request Syntax


```
POST /graphs/graphIdentifier/endpoints/ HTTP/1.1
Content-type: application/json

{
   "subnetIds": [ "string" ],
   "vpcId": "string",
   "vpcSecurityGroupIds": [ "string" ]
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [graphIdentifier](#API_CreatePrivateGraphEndpoint_RequestSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-request-uri-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [subnetIds](#API_CreatePrivateGraphEndpoint_RequestSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-request-subnetIds"></a>
Subnets in which private graph endpoint ENIs are created.  
Type: Array of strings  
Array Members: Minimum number of 1 item. Maximum number of 6 items.  
Pattern: `subnet-[a-z0-9]+`   
Required: No

 ** [vpcId](#API_CreatePrivateGraphEndpoint_RequestSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-request-vpcId"></a>
 The VPC in which the private graph endpoint needs to be created.  
Type: String  
Pattern: `vpc-[a-z0-9]+`   
Required: No

 ** [vpcSecurityGroupIds](#API_CreatePrivateGraphEndpoint_RequestSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-request-vpcSecurityGroupIds"></a>
Security groups to be attached to the private graph endpoint..  
Type: Array of strings  
Array Members: Minimum number of 1 item. Maximum number of 10 items.  
Pattern: `sg-[a-z0-9]+`   
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "status": "string",
   "subnetIds": [ "string" ],
   "vpcEndpointId": "string",
   "vpcId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [status](#API_CreatePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-response-status"></a>
Status of the private graph endpoint.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | FAILED` 

 ** [subnetIds](#API_CreatePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-response-subnetIds"></a>
Subnets in which the private graph endpoint ENIs are created.   
Type: Array of strings  
Array Members: Minimum number of 1 item. Maximum number of 6 items.  
Pattern: `subnet-[a-z0-9]+` 

 ** [vpcEndpointId](#API_CreatePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-response-vpcEndpointId"></a>
Endpoint ID of the prviate grpah endpoint.  
Type: String  
Pattern: `vpce-[0-9a-f]{17}` 

 ** [vpcId](#API_CreatePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-CreatePrivateGraphEndpoint-response-vpcId"></a>
VPC in which the private graph endpoint is created.  
Type: String  
Pattern: `vpc-[a-z0-9]+` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
A service quota was exceeded.    
 ** quotaCode **   
Service quota code of the resource for which quota was exceeded.  
 ** resourceId **   
The identifier of the resource that exceeded quota.  
 ** resourceType **   
The type of the resource that exceeded quota. Ex: Graph, Snapshot  
 ** serviceCode **   
The service code that exceeded quota.
HTTP Status Code: 402

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/CreatePrivateGraphEndpoint) 

# DeleteGraph


Deletes the specified graph. Graphs cannot be deleted if delete-protection is enabled.

## Request Syntax


```
DELETE /graphs/graphIdentifier?skipSnapshot=skipSnapshot HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [graphIdentifier](#API_DeleteGraph_RequestSyntax) **   <a name="neptunegraph-DeleteGraph-request-uri-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

 ** [skipSnapshot](#API_DeleteGraph_RequestSyntax) **   <a name="neptunegraph-DeleteGraph-request-uri-skipSnapshot"></a>
Determines whether a final graph snapshot is created before the graph is deleted. If `true` is specified, no graph snapshot is created. If `false` is specified, a graph snapshot is created before the graph is deleted.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string",
   "buildNumber": "string",
   "createTime": number,
   "deletionProtection": boolean,
   "endpoint": "string",
   "id": "string",
   "kmsKeyIdentifier": "string",
   "name": "string",
   "provisionedMemory": number,
   "publicConnectivity": boolean,
   "replicaCount": number,
   "sourceSnapshotId": "string",
   "status": "string",
   "statusReason": "string",
   "vectorSearchConfiguration": { 
      "dimension": number
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-arn"></a>
The ARN associated with the graph.  
Type: String

 ** [buildNumber](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-buildNumber"></a>
The build number associated with the graph.  
Type: String

 ** [createTime](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-createTime"></a>
The time at which the graph was created.  
Type: Timestamp

 ** [deletionProtection](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-deletionProtection"></a>
If `true`, deletion protection was enabled for the graph.  
Type: Boolean

 ** [endpoint](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-endpoint"></a>
The graph endpoint.  
Type: String

 ** [id](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-id"></a>
The unique identifier of the graph.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-kmsKeyIdentifier"></a>
The ID of the KMS key used to encrypt and decrypt graph data.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [name](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-name"></a>
The name of the graph.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!g-)[a-z][a-z0-9]*(-[a-z0-9]+)*` 

 ** [provisionedMemory](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-provisionedMemory"></a>
The number of memory-optimized Neptune Capacity Units (m-NCUs) allocated to the graph.  
Type: Integer  
Valid Range: Minimum value of 16. Maximum value of 24576.

 ** [publicConnectivity](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-publicConnectivity"></a>
If `true`, the graph has a public endpoint, otherwise not.  
Type: Boolean

 ** [replicaCount](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-replicaCount"></a>
The number of replicas for the graph.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2.

 ** [sourceSnapshotId](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-sourceSnapshotId"></a>
The ID of the snapshot from which the graph was created, if the graph was recovered from a snapshot.  
Type: String  
Pattern: `gs-[a-z0-9]{10}` 

 ** [status](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-status"></a>
The status of the graph.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | RESETTING | UPDATING | SNAPSHOTTING | FAILED | IMPORTING | STARTING | STOPPING | STOPPED` 

 ** [statusReason](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-statusReason"></a>
The reason for the status of the graph.  
Type: String

 ** [vectorSearchConfiguration](#API_DeleteGraph_ResponseSyntax) **   <a name="neptunegraph-DeleteGraph-response-vectorSearchConfiguration"></a>
Specifies the number of dimensions for vector embeddings loaded into the graph. Max = 65535  
Type: [VectorSearchConfiguration](API_VectorSearchConfiguration.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/DeleteGraph) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/DeleteGraph) 

# DeleteGraphSnapshot


Deletes the specifed graph snapshot.

## Request Syntax


```
DELETE /snapshots/snapshotIdentifier HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [snapshotIdentifier](#API_DeleteGraphSnapshot_RequestSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-request-uri-snapshotIdentifier"></a>
ID of the graph snapshot to be deleted.  
Pattern: `gs-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string",
   "id": "string",
   "kmsKeyIdentifier": "string",
   "name": "string",
   "snapshotCreateTime": number,
   "sourceGraphId": "string",
   "status": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_DeleteGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-response-arn"></a>
The ARN of the graph snapshot.  
Type: String

 ** [id](#API_DeleteGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-response-id"></a>
The unique identifier of the graph snapshot.  
Type: String  
Pattern: `gs-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_DeleteGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-response-kmsKeyIdentifier"></a>
The ID of the KMS key used to encrypt and decrypt the snapshot.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [name](#API_DeleteGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-response-name"></a>
The snapshot name. For example: `my-snapshot-1`.  
The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!gs-)[a-z][a-z0-9]*(-[a-z0-9]+)*` 

 ** [snapshotCreateTime](#API_DeleteGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-response-snapshotCreateTime"></a>
The time when the snapshot was created.  
Type: Timestamp

 ** [sourceGraphId](#API_DeleteGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-response-sourceGraphId"></a>
The graph identifier for the graph from which the snapshot was created.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [status](#API_DeleteGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-DeleteGraphSnapshot-response-status"></a>
The status of the graph snapshot.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | FAILED` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/DeleteGraphSnapshot) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/DeleteGraphSnapshot) 

# DeletePrivateGraphEndpoint


Deletes a private graph endpoint.

## Request Syntax


```
DELETE /graphs/graphIdentifier/endpoints/vpcId HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [graphIdentifier](#API_DeletePrivateGraphEndpoint_RequestSyntax) **   <a name="neptunegraph-DeletePrivateGraphEndpoint-request-uri-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

 ** [vpcId](#API_DeletePrivateGraphEndpoint_RequestSyntax) **   <a name="neptunegraph-DeletePrivateGraphEndpoint-request-uri-vpcId"></a>
The ID of the VPC where the private endpoint is located.  
Pattern: `vpc-[a-z0-9]+`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "status": "string",
   "subnetIds": [ "string" ],
   "vpcEndpointId": "string",
   "vpcId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [status](#API_DeletePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-DeletePrivateGraphEndpoint-response-status"></a>
The status of the delete operation.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | FAILED` 

 ** [subnetIds](#API_DeletePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-DeletePrivateGraphEndpoint-response-subnetIds"></a>
The subnet IDs involved.  
Type: Array of strings  
Array Members: Minimum number of 1 item. Maximum number of 6 items.  
Pattern: `subnet-[a-z0-9]+` 

 ** [vpcEndpointId](#API_DeletePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-DeletePrivateGraphEndpoint-response-vpcEndpointId"></a>
The ID of the VPC endpoint that was deleted.  
Type: String  
Pattern: `vpce-[0-9a-f]{17}` 

 ** [vpcId](#API_DeletePrivateGraphEndpoint_ResponseSyntax) **   <a name="neptunegraph-DeletePrivateGraphEndpoint-response-vpcId"></a>
The ID of the VPC where the private endpoint was deleted.  
Type: String  
Pattern: `vpc-[a-z0-9]+` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/DeletePrivateGraphEndpoint) 

# ExecuteQuery


Execute an openCypher query.

 When invoking this operation in a Neptune Analytics cluster, the IAM user or role making the request must have a policy attached that allows one of the following IAM actions in that cluster, depending on the query: 
+ neptune-graph:ReadDataViaQuery
+ neptune-graph:WriteDataViaQuery
+ neptune-graph:DeleteDataViaQuery

## Request Syntax


```
POST /queries HTTP/1.1
graphIdentifier: graphIdentifier
Content-type: application/json

{
   "explain": "string",
   "language": "string",
   "parameters": { 
      "string" : JSON value 
   },
   "planCache": "string",
   "query": "string",
   "queryTimeoutMilliseconds": number
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [graphIdentifier](#API_ExecuteQuery_RequestSyntax) **   <a name="neptunegraph-ExecuteQuery-request-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [explain](#API_ExecuteQuery_RequestSyntax) **   <a name="neptunegraph-ExecuteQuery-request-explain"></a>
The explain mode parameter returns a query explain instead of the actual query results. A query explain can be used to gather insights about the query execution such as planning decisions, time spent on each operator, solutions flowing etc.  
Type: String  
Valid Values: `STATIC | DETAILS`   
Required: No

 ** [language](#API_ExecuteQuery_RequestSyntax) **   <a name="neptunegraph-ExecuteQuery-request-language"></a>
The query language the query is written in. Currently only openCypher is supported.  
Type: String  
Valid Values: `OPEN_CYPHER`   
Required: Yes

 ** [parameters](#API_ExecuteQuery_RequestSyntax) **   <a name="neptunegraph-ExecuteQuery-request-parameters"></a>
The data parameters the query can use in JSON format. For example: \$1"name": "john", "age": 20\$1. (optional)   
Type: String to JSON value map  
Required: No

 ** [planCache](#API_ExecuteQuery_RequestSyntax) **   <a name="neptunegraph-ExecuteQuery-request-planCache"></a>
Query plan cache is a feature that saves the query plan and reuses it on successive executions of the same query. This reduces query latency, and works for both `READ` and `UPDATE` queries. The plan cache is an LRU cache with a 5 minute TTL and a capacity of 1000.  
Type: String  
Valid Values: `ENABLED | DISABLED | AUTO`   
Required: No

 ** [query](#API_ExecuteQuery_RequestSyntax) **   <a name="neptunegraph-ExecuteQuery-request-query"></a>
The query string to be executed.  
Type: String  
Required: Yes

 ** [queryTimeoutMilliseconds](#API_ExecuteQuery_RequestSyntax) **   <a name="neptunegraph-ExecuteQuery-request-queryTimeoutMilliseconds"></a>
Specifies the query timeout duration, in milliseconds. (optional)  
Type: Integer  
Required: No

## Response Syntax


```
HTTP/1.1 200

payload
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The response returns the following as the HTTP body.

 ** [payload](#API_ExecuteQuery_ResponseSyntax) **   <a name="neptunegraph-ExecuteQuery-response-payload"></a>
The query results.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Raised in case of an authentication or authorization failure.    
 ** message **   
A message describing the problem.
HTTP Status Code: 403

 ** ConflictException **   
Raised when a conflict is encountered.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason for the conflict exception.
HTTP Status Code: 409

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** UnprocessableException **   
Request cannot be processed due to known reasons. Eg. partition full.    
 ** reason **   
The reason for the unprocessable exception.
HTTP Status Code: 422

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/ExecuteQuery) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/ExecuteQuery) 

# GetExportTask


Retrieves a specified export task.

## Request Syntax


```
GET /exporttasks/taskIdentifier HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [taskIdentifier](#API_GetExportTask_RequestSyntax) **   <a name="neptunegraph-GetExportTask-request-uri-taskIdentifier"></a>
The unique identifier of the export task.  
Pattern: `t-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "destination": "string",
   "exportFilter": { 
      "edgeFilter": { 
         "string" : { 
            "properties": { 
               "string" : { 
                  "multiValueHandling": "string",
                  "outputType": "string",
                  "sourcePropertyName": "string"
               }
            }
         }
      },
      "vertexFilter": { 
         "string" : { 
            "properties": { 
               "string" : { 
                  "multiValueHandling": "string",
                  "outputType": "string",
                  "sourcePropertyName": "string"
               }
            }
         }
      }
   },
   "exportTaskDetails": { 
      "numEdgesWritten": number,
      "numVerticesWritten": number,
      "progressPercentage": number,
      "startTime": number,
      "timeElapsedSeconds": number
   },
   "format": "string",
   "graphId": "string",
   "kmsKeyIdentifier": "string",
   "parquetType": "string",
   "roleArn": "string",
   "status": "string",
   "statusReason": "string",
   "taskId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [destination](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-destination"></a>
The Amazon S3 URI of the export task where data will be exported.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.

 ** [exportFilter](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-exportFilter"></a>
The export filter of the export task.  
Type: [ExportFilter](API_ExportFilter.md) object

 ** [exportTaskDetails](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-exportTaskDetails"></a>
The details of the export task.  
Type: [ExportTaskDetails](API_ExportTaskDetails.md) object

 ** [format](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-format"></a>
The format of the export task.  
Type: String  
Valid Values: `PARQUET | CSV` 

 ** [graphId](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-graphId"></a>
The source graph identifier of the export task.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-kmsKeyIdentifier"></a>
The KMS key identifier of the export task.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [parquetType](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-parquetType"></a>
The parquet type of the export task.  
Type: String  
Valid Values: `COLUMNAR` 

 ** [roleArn](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-roleArn"></a>
The ARN of the IAM role that will allow data to be exported to the destination.  
Type: String  
Pattern: `arn:aws[^:]*:iam::\d{12}:(role|role/service-role)(/[\w+=,.@-]+)+` 

 ** [status](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-status"></a>
The current status of the export task.  
Type: String  
Valid Values: `INITIALIZING | EXPORTING | SUCCEEDED | FAILED | CANCELLING | CANCELLED | DELETED` 

 ** [statusReason](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-statusReason"></a>
The reason that the export task has this status value.  
Type: String

 ** [taskId](#API_GetExportTask_ResponseSyntax) **   <a name="neptunegraph-GetExportTask-response-taskId"></a>
The unique identifier of the export task.  
Type: String  
Pattern: `t-[a-z0-9]{10}` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/GetExportTask) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/GetExportTask) 

# GetGraph


Gets information about a specified graph.

## Request Syntax


```
GET /graphs/graphIdentifier HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [graphIdentifier](#API_GetGraph_RequestSyntax) **   <a name="neptunegraph-GetGraph-request-uri-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string",
   "buildNumber": "string",
   "createTime": number,
   "deletionProtection": boolean,
   "endpoint": "string",
   "id": "string",
   "kmsKeyIdentifier": "string",
   "name": "string",
   "provisionedMemory": number,
   "publicConnectivity": boolean,
   "replicaCount": number,
   "sourceSnapshotId": "string",
   "status": "string",
   "statusReason": "string",
   "vectorSearchConfiguration": { 
      "dimension": number
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-arn"></a>
The ARN associated with the graph.  
Type: String

 ** [buildNumber](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-buildNumber"></a>
The build number of the graph.  
Type: String

 ** [createTime](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-createTime"></a>
The time at which the graph was created.  
Type: Timestamp

 ** [deletionProtection](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-deletionProtection"></a>
If `true`, deletion protection is enabled for the graph.  
Type: Boolean

 ** [endpoint](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-endpoint"></a>
The graph endpoint.  
Type: String

 ** [id](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-id"></a>
The unique identifier of the graph.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-kmsKeyIdentifier"></a>
The ID of the KMS key used to encrypt and decrypt graph data.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [name](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-name"></a>
The name of the graph.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!g-)[a-z][a-z0-9]*(-[a-z0-9]+)*` 

 ** [provisionedMemory](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-provisionedMemory"></a>
The number of memory-optimized Neptune Capacity Units (m-NCUs) allocated to the graph.  
Type: Integer  
Valid Range: Minimum value of 16. Maximum value of 24576.

 ** [publicConnectivity](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-publicConnectivity"></a>
If `true`, the graph has a public endpoint, otherwise not.  
Type: Boolean

 ** [replicaCount](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-replicaCount"></a>
The number of replicas for the graph.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2.

 ** [sourceSnapshotId](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-sourceSnapshotId"></a>
The ID of the snapshot from which the graph was created, if it was created from a snapshot.  
Type: String  
Pattern: `gs-[a-z0-9]{10}` 

 ** [status](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-status"></a>
The status of the graph.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | RESETTING | UPDATING | SNAPSHOTTING | FAILED | IMPORTING | STARTING | STOPPING | STOPPED` 

 ** [statusReason](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-statusReason"></a>
The reason that the graph has this status.  
Type: String

 ** [vectorSearchConfiguration](#API_GetGraph_ResponseSyntax) **   <a name="neptunegraph-GetGraph-response-vectorSearchConfiguration"></a>
Specifies the number of dimensions for vector embeddings loaded into the graph. Max = 65535  
Type: [VectorSearchConfiguration](API_VectorSearchConfiguration.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/GetGraph) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/GetGraph) 

# GetGraphSnapshot


Retrieves a specified graph snapshot.

## Request Syntax


```
GET /snapshots/snapshotIdentifier HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [snapshotIdentifier](#API_GetGraphSnapshot_RequestSyntax) **   <a name="neptunegraph-GetGraphSnapshot-request-uri-snapshotIdentifier"></a>
The ID of the snapshot to retrieve.  
Pattern: `gs-[a-z0-9]{10}`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string",
   "id": "string",
   "kmsKeyIdentifier": "string",
   "name": "string",
   "snapshotCreateTime": number,
   "sourceGraphId": "string",
   "status": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_GetGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-GetGraphSnapshot-response-arn"></a>
The ARN of the graph snapshot.  
Type: String

 ** [id](#API_GetGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-GetGraphSnapshot-response-id"></a>
The unique identifier of the graph snapshot.  
Type: String  
Pattern: `gs-[a-z0-9]{10}` 

 ** [kmsKeyIdentifier](#API_GetGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-GetGraphSnapshot-response-kmsKeyIdentifier"></a>
The ID of the KMS key used to encrypt and decrypt the snapshot.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [name](#API_GetGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-GetGraphSnapshot-response-name"></a>
The snapshot name. For example: `my-snapshot-1`.  
The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `(?!gs-)[a-z][a-z0-9]*(-[a-z0-9]+)*` 

 ** [snapshotCreateTime](#API_GetGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-GetGraphSnapshot-response-snapshotCreateTime"></a>
The time when the snapshot was created.  
Type: Timestamp

 ** [sourceGraphId](#API_GetGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-GetGraphSnapshot-response-sourceGraphId"></a>
The graph identifier for the graph for which a snapshot is to be created.  
Type: String  
Pattern: `g-[a-z0-9]{10}` 

 ** [status](#API_GetGraphSnapshot_ResponseSyntax) **   <a name="neptunegraph-GetGraphSnapshot-response-status"></a>
The status of the graph snapshot.  
Type: String  
Valid Values: `CREATING | AVAILABLE | DELETING | FAILED` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

 ** ThrottlingException **   
The exception was interrupted by throttling.    
 ** message **   
A message describing the problem.
HTTP Status Code: 429

 ** ValidationException **   
A resource could not be validated.    
 ** message **   
A message describing the problem.  
 ** reason **   
The reason that the resource could not be validated.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/neptune-graph-2023-11-29/GetGraphSnapshot) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/neptune-graph-2023-11-29/GetGraphSnapshot) 

# GetGraphSummary


Gets a graph summary for a property graph.

## Request Syntax


```
GET /summary?mode=mode HTTP/1.1
graphIdentifier: graphIdentifier
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [graphIdentifier](#API_GetGraphSummary_RequestSyntax) **   <a name="neptunegraph-GetGraphSummary-request-graphIdentifier"></a>
The unique identifier of the Neptune Analytics graph.  
Pattern: `g-[a-z0-9]{10}`   
Required: Yes

 ** [mode](#API_GetGraphSummary_RequestSyntax) **   <a name="neptunegraph-GetGraphSummary-request-uri-mode"></a>
The summary mode can take one of two values: `basic` (the default), and `detailed`.  
Valid Values: `BASIC | DETAILED` 

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "graphSummary": { 
      "edgeLabels": [ "string" ],
      "edgeProperties": [ 
         { 
            "string" : number 
         }
      ],
      "edgeStructures": [ 
         { 
            "count": number,
            "edgeProperties": [ "string" ]
         }
      ],
      "nodeLabels": [ "string" ],
      "nodeProperties": [ 
         { 
            "string" : number 
         }
      ],
      "nodeStructures": [ 
         { 
            "count": number,
            "distinctOutgoingEdgeLabels": [ "string" ],
            "nodeProperties": [ "string" ]
         }
      ],
      "numEdgeLabels": number,
      "numEdgeProperties": number,
      "numEdges": number,
      "numNodeLabels": number,
      "numNodeProperties": number,
      "numNodes": number,
      "totalEdgePropertyValues": number,
      "totalNodePropertyValues": number
   },
   "lastStatisticsComputationTime": "string",
   "version": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [graphSummary](#API_GetGraphSummary_ResponseSyntax) **   <a name="neptunegraph-GetGraphSummary-response-graphSummary"></a>
The graph summary.  
Type: [GraphDataSummary](API_GraphDataSummary.md) object

 ** [lastStatisticsComputationTime](#API_GetGraphSummary_ResponseSyntax) **   <a name="neptunegraph-GetGraphSummary-response-lastStatisticsComputationTime"></a>
The timestamp, in ISO 8601 format, of the time at which Neptune Analytics last computed statistics.  
Type: Timestamp

 ** [version](#API_GetGraphSummary_ResponseSyntax) **   <a name="neptunegraph-GetGraphSummary-response-version"></a>
Display the version of this tool.  
Type: String

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Raised in case of an authentication or authorization failure.    
 ** message **   
A message describing the problem.
HTTP Status Code: 403

 ** InternalServerException **   
A failure occurred on the server.    
 ** message **   
A message describing the problem.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
A specified resource could not be located.    
 ** message **   
A message describing the problem.
HTTP Status Code: 404

[...]
